const utils = require('./utils')
const FOUNDATION_PATH = require.resolve('foundation-emails/dist/foundation-emails.css')
const BASE_TEMPLATE_PATH = require.resolve('./base-template.hbs')

const foundation = utils.readFile.sync(FOUNDATION_PATH, 'utf-8')
const baseTemplate = utils.readFile.sync(BASE_TEMPLATE_PATH, 'utf-8')
  .replace('{{FOUNDATION}}', `<style>${foundation}</style>\n`)

const renderCss = styles => styles
  .map(style => `<style>${style}</style>`)
  .join('\n')

module.exports = function createTemplate ({ css, body }) {
  return baseTemplate
    .replace('{{CSS}}', renderCss(css))
    .replace('{{BODY}}', body)
}
