const { Inky } = require('inky')
const juice = require('juice')

const utils = require('./utils')
const createTemplate = require('./create-template')
const inky = new Inky()

const inkify = html => inky
  .releaseTheKraken(html, { decodeEntities: false })
  .replace(/\{\{&gt;/g, '{{>')
  .replace(/\{\{#&gt;/g, '{{#>')

exports.compileTemplate = (hbs, { body, css }) => utils.compose(
  wrapTemplate,
  html => hbs.compile(html),
  inkify,
  data => createTemplate(data)
)({ body, css })

exports.registerPartials = (hbs, partials) => utils.eachObj(
  (name, partial) => hbs.registerPartial(name, inkify(partial)),
  partials
)

exports.registerHelpers = (hbs, helpers) => utils.eachObj(
  (name, helper) => hbs.registerHelper(name, helper),
  helpers
)

function wrapTemplate (template) {
  return utils.compose(
    juice,
    data => template(data)
  )
}
